Fix quagga user and dirs
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
39       else
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
41       fi
42     else
43       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
44     fi
45     SDN_IMAGE=opendaylight
46   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
47     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
48     SDN_IMAGE=opendaylight
49   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
50     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
51     exit 1
52     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
53     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
54     #else
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
56     #fi
57     #SDN_IMAGE=onos
58   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
59     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
60     exit 1
61   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
62     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
63     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
64       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
65     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
66       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
67     fi
68     SDN_IMAGE=opendaylight
69   else
70     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
71     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
72     exit 1
73   fi
74
75   # Enable Tacker
76   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
77     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
78   fi
79
80   # Enable Congress
81   if [ "${deploy_options_array['congress']}" == 'True' ]; then
82     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
83   fi
84
85   # Enable Real Time Kernel (kvm4nfv)
86   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
87     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
88   fi
89
90   # Make sure the correct overcloud image is available
91   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
92       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
93       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
94       exit 1
95   fi
96
97   echo "Copying overcloud image to Undercloud"
98   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
99   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
100
101   # disable neutron openvswitch agent from starting
102   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
103       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
104       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
105       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
106                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
107                                                -a overcloud-full.qcow2
108 EOI
109   fi
110
111   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
112       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
113       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
114       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
115                                                --run-command "sudo usermod -a -G quaggavt quagga" \
116                                                --run-command "sudo mkdir -p /var/run/quagga/" \
117                                                --run-command "sudo chown quagga:quagga -R /var/run/quagga/" \
118                                                --run-command "systemctl enable zrpcd" \
119                                                -a overcloud-full.qcow2
120 EOI
121   fi
122
123   # Install ovs-dpdk inside the overcloud image if it is enabled.
124   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
125     # install dpdk packages before ovs
126     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
127
128     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
129       cat << EOF > vfio_pci.modules
130 #!/bin/bash
131 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
132 EOF
133
134       cat << EOF > uio_pci_generic.modules
135 #!/bin/bash
136 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
137 EOF
138
139       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
140                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
141                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
142                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
143                                                -a overcloud-full.qcow2
144
145       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
146         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
147       fi
148
149 EOI
150
151   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
152     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
153     exit 1
154   fi
155
156   if [ "$debug" == 'TRUE' ]; then
157     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
158   fi
159
160   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
161   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
162     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
163          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
164                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
165                                                   -a overcloud-full.qcow2
166 EOI
167   fi
168
169   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
170   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
171     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
172       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
173                                                -a overcloud-full.qcow2
174 EOI
175     # Configure routing node for odl_l3-fdio
176     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
177       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
178         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
179 EOI
180     fi
181   fi
182
183   if [ -n "${deploy_options_array['performance']}" ]; then
184     ovs_dpdk_perf_flag="False"
185     for option in "${performance_options[@]}" ; do
186       arr=($option)
187       # use compute's kernel settings for all nodes for now.
188       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
189         kernel_args+=" ${arr[2]}=${arr[3]}"
190       fi
191       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
192          eval "${arr[2]}=${arr[3]}"
193          ovs_dpdk_perf_flag="True"
194       fi
195     done
196
197     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
198       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
199       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
200       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
201 EOI
202
203     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
204       for ovs_option in ${!ovs_option_heat_arr[@]}; do
205         if [ -n "${!ovs_option}" ]; then
206           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
207             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
208 EOI
209         fi
210       done
211     fi
212   fi
213
214   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
215     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
216       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
217         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
218           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
219 EOI
220       else
221         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
222         exit 1
223       fi
224     fi
225   fi
226
227   # Set ODL version accordingly
228   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
229     case "${deploy_options_array['odl_version']}" in
230       beryllium) odl_version=''
231               ;;
232       boron)  odl_version='boron'
233               ;;
234       carbon) odl_version='master'
235               ;;
236       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
237          exit 1
238          ;;
239     esac
240
241     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
242       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
243                                                --run-command "yum -y install /root/${odl_version}/*" \
244                                                -a overcloud-full.qcow2
245 EOI
246   fi
247
248   # Override ODL if FDIO and ODL L2
249   if [[ "${deploy_options_array['vpp']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' && "${deploy_options_array['sdn_l3']}" == "False" ]]; then
250     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
251          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
252                                                   --run-command "yum -y install /root/fdio_l2/opendaylight*.rpm" \
253                                                   -a overcloud-full.qcow2
254 EOI
255   fi
256
257   # check if ceph should be enabled
258   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
259     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
260   fi
261
262   # get number of nodes available in inventory
263   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
264   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
265
266   # check if HA is enabled
267   if [[ "$ha_enabled" == "True" ]]; then
268     if [ "$num_control_nodes" -lt 3 ]; then
269       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
270       exit 1
271     else
272      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
273      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
274      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
275     fi
276   else
277     if [ "$num_control_nodes" -lt 1 ]; then
278       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
279       exit 1
280     fi
281   fi
282
283   if [ "$num_compute_nodes" -le 0 ]; then
284     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
285     exit 1
286   else
287     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
288     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
289   fi
290
291   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
292
293   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
294   if [[ "$virtual" == "TRUE" ]]; then
295      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
296   fi
297
298   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
299
300   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
301 # Create a key for use by nova for live migration
302 echo "Creating nova SSH key for nova resize support"
303 ssh-keygen -f nova_id_rsa -b 1024 -P ""
304 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
305 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
306 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
307 mv -f opnfv-environment-new.yaml ${ENV_FILE}
308
309 source stackrc
310 set -o errexit
311 # Workaround for APEX-207 where sometimes swift proxy is down
312 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
313   sudo systemctl restart openstack-swift-proxy
314 fi
315 echo "Uploading overcloud glance images"
316 openstack overcloud image upload
317
318 echo "Configuring undercloud and discovering nodes"
319 openstack baremetal import --json instackenv.json
320
321 if [[ -z "$virtual" ]]; then
322   openstack baremetal introspection bulk start
323   if [[ -n "$root_disk_list" ]]; then
324     openstack baremetal configure boot --root-device=${root_disk_list}
325   else
326     openstack baremetal configure boot
327   fi
328 else
329   openstack baremetal configure boot
330 fi
331
332 echo "Configuring flavors"
333 for flavor in baremetal control compute; do
334   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
335   if openstack flavor list | grep \${flavor}; then
336     openstack flavor delete \${flavor}
337   fi
338   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
339   if ! openstack flavor list | grep \${flavor}; then
340     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
341   fi
342 done
343 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
344 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
345 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
346 echo "Configuring nameserver on ctlplane network"
347 dns_server_ext=''
348 for dns_server in ${dns_servers}; do
349   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
350 done
351 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
352 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
353 echo "Executing overcloud deployment, this should run for an extended period without output."
354 sleep 60 #wait for Hypervisor stats to check-in to nova
355 # save deploy command so it can be used for debugging
356 cat > deploy_command << EOF
357 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
358 EOF
359 EOI
360
361   if [ "$interactive" == "TRUE" ]; then
362     if ! prompt_user "Overcloud Deployment"; then
363       echo -e "${blue}INFO: User requests exit${reset}"
364       exit 0
365     fi
366   fi
367
368   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
369 source stackrc
370 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
371 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
372   $(typeset -f debug_stack)
373   debug_stack
374   exit 1
375 fi
376 EOI
377
378   # Configure DPDK and restart ovs agent after bringing up br-phy
379   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
380     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
381 source stackrc
382 set -o errexit
383 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
384 echo "Checking DPDK status and bringing up br-phy on \$node"
385 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
386 set -o errexit
387 sudo dpdk-devbind -s
388 sudo ifup br-phy
389 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
390   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
391   sudo systemctl restart neutron-openvswitch-agent
392 fi
393 EOF
394 done
395 EOI
396   fi
397
398   if [ "$debug" == 'TRUE' ]; then
399       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
400 source overcloudrc
401 echo "Keystone Endpoint List:"
402 openstack endpoint list
403 echo "Keystone Service List"
404 openstack service list
405 EOI
406   fi
407 }